QTARGET_VERSION = "2.02"
QTARGET_ADDONLOCATION = "Interface\\AddOns\\Qtarget\\"
QTARGET_TITLE = "Quick Target"
QTARGET_SUBMIT_LABEL = "Save macro"
--QTARGET_SUBMIT_LABEL = "Target" -- can not target anymore
QTARGET_GET_LABEL = "Current"
QTARGET_UPDATE_RATE = 0.1 -- brief delay to prepare edit box
QTARGET_CONTINUOUS_RATE = 2.0 -- slow since player moves slowly anyway
QTARGET_CONTINUOUSFLASH_RATE = 0.5 -- faster to show in progress

QTARGET_FINDCORPSE = "Find Corpse"
QTARGET_CONTINUOUS = "Continuous"

Qtarget_this = ""
QtargetZoneData = { }
Qtarget_LastZone = { }

Qtarget_local = { }
Qtarget_local.TimeSinceLastUpdate = 0
Qtarget_local.TimeSinceLastContinuous = 0
Qtarget_local.TimeSinceLastContinuousFlash = 0
Qtarget_local.TimeSinceLastContinuousFlashIteration = 0
Qtarget_local.QtargetTargetEditNeedFocus = 0
Qtarget_local.ContinuousEnabled = nil
Qtarget_local.FindCorpse = nil
Qtarget_local.Continuous = nil
Qtarget_local.isCombat = nil
Qtarget_local.isSavePending = nil
Qtarget_local.isSavemacroID = nil
Qtarget_local.isSavename = nil
Qtarget_local.isSaveicon = nil
Qtarget_local.isSavebody = nil
Qtarget_local.isSaveloc = nil
Qtarget_local.isSaveperCharacter = nil
Qtarget_local.lasttarget = ""

Qtarget_pagebk = "" -- temporary storage for macro

--Qtarget = { } -- saved variable
--RegisterForSave("Qtarget")

function Qtarget_Default()
	-- reset variables to default values
	Qtarget = { } -- saved variable
	Qtarget.QtargetLocked = nil
	Qtarget_local.lasttarget = ""
end

function Qtarget_OnLoad()
	this:RegisterEvent("VARIABLES_LOADED") 
	this:RegisterEvent("PLAYER_TARGET_CHANGED")
	this:RegisterEvent("MINIMAP_UPDATE_ZOOM") 
	this:RegisterEvent("UNIT_FOCUS")
	this:RegisterEvent("PLAYER_REGEN_ENABLED")
	this:RegisterEvent("PLAYER_REGEN_DISABLED")
	this:RegisterEvent("PLAYER_LEAVE_COMBAT")
	this:RegisterForDrag("LeftButton")

	SlashCmdList["QTARGET"] = Qtarget_Slashhandler
	SLASH_QTARGET1 = "/qtarget"
	SLASH_QTARGET2 = "/qt"
	SLASH_QTARGET3 = "/quicktarget"

	if not Qtarget then
		Qtarget_Default()
	end

	Qtarget_Chat("Quick Target v" ..QTARGET_VERSION .." loaded. Type " ..SLASH_QTARGET2 .." to open.", 1, 1, 1)
end

function Qtarget_Init()
end

function Qtarget_InitLocal()
	-- see section, event == "VARIABLES_LOADED"
	Qtarget_Loadwindow()
	Qtarget_LoadContinents(GetMapContinents())
	QtargetContinuousText:SetTextColor(1.0, 1.0, 0.0) -- yellow, restored
	QtargetFindCorpseText:SetTextColor(1.0, 1.0, 0.0) -- yellow, restored
	Qtarget_UpdateLock()

	QtargetContinuous:Hide() -- no longer applicable after patches
	QtargetContinuousText:Hide() -- no longer applicable after patches
end

function Qtarget_Slashhandler(qtarget_newtarget)
	if (qtarget_newtarget == nil or qtarget_newtarget == "") then
		if( QtargetFrame:IsVisible() ) then
			Qtarget_Target(nil, 1)
			--HideUIPanel(QtargetFrame) -- not applicable, window must stay open
		else
			ShowUIPanel(QtargetFrame)
			Qtarget_local.QtargetTargetEditNeedFocus = 1
		end

	else
		if( QtargetFrame:IsVisible() ) then
			Qtarget_Target(qtarget_newtarget, 1)
		else
			Qtarget_Target(qtarget_newtarget)
		end
	end
end

function Qtarget_Target(qtarget_newtarget, isFast)
	local qtarget_newtargetlen
	local qtarget_selected

	if (qtarget_newtarget == nil or qtarget_newtarget == "") then
		qtarget_newtarget = QtargetTargetEdit:GetText()
		if not qtarget_newtarget then qtarget_newtarget = ""; end -- empty GetText() may return nil
	end

	-- Build macro
	-- only if using slash command and name changes otherwise slows down game all the time
	-- running after pressing 'savemacro' or other way always builds macro to be sure
	local isBuild = nil
	if not isFast then -- always build
		isBuild = 1
	elseif Qtarget_local.lasttarget ~= qtarget_newtarget and strlen(qtarget_newtarget) > 0 then -- after name change
		isBuild = 1
	end

	if isBuild then
		local name = "Target" -- name of macro to create
		local icon = 2 -- picture of something to target, range from 1 to ...
		local body = ""
		local loc = 1
		local perCharacter = nil	

		-- It is possible to create macros with duplicate names. You should enumerate the current macros using GetNumMacros() and GetMacroIconInfo(macroId) to ensure that your new macro name doesn't already exist.
		local macroID = nil
		for i = 1, GetNumMacros(), 1 do
			local iname, itexture, ibody, iloc = GetMacroInfo(i)
			--local Texture = GetMacroIconInfo(i) -- alternative
			if iname and strlower(iname) == strlower(name) then
				macroID = i
				break -- found
			end
		end

		--DeleteMacro(name) -- not safe because loose icons in actionbars

		if GetNumMacros() > 17 and not macroID then
			-- It is possible to create more macros than the UI can display. Call GetNumMacros() to ensure there are no more than 17 macros (18 is the current UI limit per account/per character) before calling CreateMacro(). 
			-- Once created though, we do not have to worry about this checking all the time
			Qtarget_Chat("Qtargetx failed. There may be too many macros and we need room for one more.")

		else
			-- build macro contents
			-- has to be updated each time because /target currently can not accept variable

			-- Open window if not open
			-- save macro immediately if already open
			-- saving can update rest of macro while running, so no old information
			body = "/qt"

			-- Target as usual
			-- need name spelled out, no variable applicable
			body = body .."\n/target " ..strlower(qtarget_newtarget)

			-- Unselect if not the target we were looking for
			-- check if left portion of name matches quick target text
			-- uses actionpage temporarily to notify /cleartarget (out of combat)
			body = body
			  .."\n/script Qtarget_pagebk=Qtarget_page(1)"
			  .."\n/script Qtarget_page(Qtarget_isvalid(" ..'"' ..strlower(qtarget_newtarget) ..'"' .."))"

			-- Clear if invalid target
			body = body
			  .."\n/cleartarget [actionbar:2]"

			-- Clear if corpse
			if not Qtarget_local.FindCorpse then
				body = body
				  .."\n/cleartarget [dead]"
				--  .."\n/cleartarget [actionbar:2/dead]" -- for some reason this doesn't work to save space
			end

			-- Restore actionpage
			body = body
			  .."\n/script Qtarget_page(Qtarget_pagebk)"

			--[[
			body = body
			  .."\n/script Qt_page(1)"
			  .."\n/script if UnitName(" ..'"' .."target" ..'"' ..") then"
			  .." if " ..'"' ..strlower(qtarget_newtarget) ..'"' .."~=strlower(strsub(UnitName(" ..'"' .."target" ..'"' .."),0," ..strlen(qtarget_newtarget) ..")) then"
			  .." Qt_page(2);end;end"
			  .."\n/cleartarget [actionbar:2/dead]"
			  .."\n/script Qt_page(1)"
			]]

			if strlen(body) > 255 then -- limit is 255
				Qtarget_Chat("Qtargetx failed. Please reduce the size of the name.")

			elseif Qtarget_local.isCombat then -- not in combat
				-- can not change macro while fighting, so do later
				Qtarget_local.isSavePending = 1
				Qtarget_local.isSavemacroID = macroID
				Qtarget_local.isSavename = name
				Qtarget_local.isSaveicon = icon
				Qtarget_local.isSavebody = body
				Qtarget_local.isSaveloc = loc
				Qtarget_local.isSaveperCharacter = perCharacter

				QtargetSubmitButton:SetTextColor(GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b)

			else -- save now
				Qtarget_local.isSavePending = 1
				Qtarget_local.isSavemacroID = macroID
				Qtarget_local.isSavename = name
				Qtarget_local.isSaveicon = icon
				Qtarget_local.isSavebody = body
				Qtarget_local.isSaveloc = loc
				Qtarget_local.isSaveperCharacter = perCharacter
				Qtarget_OnUpdate(0)
			end
		end

		-- Samples:
		--[[
		-- target, ignore corpse
		/qt
		/cleartarget
		/target fire
		/cleartarget [dead]

		-- target, only corpse
		/qt
		/cleartarget
		/target fire
		/cleartarget [nodead]

		-- cleartarget if not match using variable (not possible)
		/script DISGUISE = nil
		/script if UnitName("target") then if strlower("wisp") ~= strlower(strsub(UnitName("target"), 0, 4)) then DISGUISE = 1 end end

		-- clear target if not match using equipped weapon slot (preferrably ammo)
		/cleartarget [equipped:main hand]

		-- clear target based on actionbar
		/script ChangeActionBarPage(1)
		/script if UnitName("target") then if strlower("wisp") ~= strlower(strsub(UnitName("target"), 0, 4)) then ChangeActionBarPage(2) end end
		/cleartarget [actionbar:2]
		/script ChangeActionBarPage(1)

		-- clear target based on actionbar or dead
		/qt
		/target wis
		/script ChangeActionBarPage(1)
		/script if UnitName("target") then if "wisp"~=strlower(strsub(UnitName("target"),0,4)) then ChangeActionBarPage(2);end;end
		/cleartarget [actionbar:2/dead]
		/script ChangeActionBarPage(1)

		/qt
		/target wis
		/script Qt_page(1)
		/script if UnitName("target") then if "wisp"~=strlower(strsub(UnitName("target"),0,4)) then Qt_page(2);end;end
		/cleartarget [actionbar:2/dead]
		/script Qt_page(1)
		function Qt_page(page)
			ChangeActionBarPage(page)
		end

		/qt
		/target hc
		/script Qtarget_pagebk=Qtarget_page(1)
		/script Qtarget_page(Qtarget_isvalid("hc"))
		/cleartarget [actionbar:2]
		/cleartarget [dead]
		/script Qtarget_page(Qtarget_pagebk)
		]]

		-- Alternative,
		-- save name to global variable that macro can use
		-- but /target can not use variables in macros though
		--DISGUISE = qtarget_newtarget -- so external functions/macros can use name too
		--Qtarget_this = qtarget_newtarget -- so external functions/macros can use name too

		--[[
		-- Broken by patch 2.0
		TargetByName(qtarget_newtarget) -- regular match
		--TargetByName(qtarget_newtarget, true) -- exact match
		-- exact match fails because need entire name spelled out correctly which is annoying
		-- regular match finds anything that starts with the first letter in text, annoying

		-- Unselect if not the target we were looking for
		qtarget_newtargetlen = strlen(qtarget_newtarget)
		if (UnitName("target") == nil or UnitName("target") == "") then -- nothing selected
			-- TargetByName() already shows msg, 'unknown unit', 'you have no target'
		else
			-- Check if left portion of name matches quick target text
			qtarget_selected = strsub(UnitName("target"), 0, qtarget_newtargetlen)
			-- sample: strsub("abcDef",2,4) == "cD" 
			if (strupper(qtarget_newtarget) == strupper(qtarget_selected)) then -- matches
			else
				-- No match, so clear and show msg
				ClearTarget()
				TargetByName("#123unknown") -- force to find nothing and show msg, 'unknown unit', 'you have no target'
			end
		end

		-- Unselect if corpse
		if (UnitName("target") == nil or UnitName("target") == "") then -- nothing selected
			-- TargetByName() already shows target, 'unknown unit', or 'you have no target'
		elseif (UnitIsDead("target") == nil) then -- not dead
			-- TargetByName() already shows target, 'unknown unit', or 'you have no target'
		elseif (QtargetFindCorpse:GetChecked()) then -- ignore corpse
			-- TargetByName() already shows target, 'unknown unit', or 'you have no target'
		else
			ClearTarget()
			TargetByName("#123unknown") -- force to find nothing and show msg, 'unknown unit', 'you have no target'
		end
		]]

	end

	Qtarget_local.lasttarget = qtarget_newtarget
	qtarget_newtarget = ""
	QtargetTargetEdit:HighlightText(0, 0)
	QtargetTargetEdit:Hide()
	QtargetTargetEdit:Show()

	-- Enable when continuous check on
	if QtargetContinuous:GetChecked() then Qtarget_local.ContinuousEnabled = true end
end

function Qtarget_page(page)
	-- a smaller function name is used to fit in macro
	local backuppage = GetActionBarPage()
	if not Qtarget_local.isCombat then -- ignore in combat
		ChangeActionBarPage(page)
	else
		-- Can not use to clear target if invalid or dead
	end
	return backuppage
end

function Qtarget_isvalid(qtarget_newtarget)
	local isValid = 0

	isValid = 1 -- page 1
	if UnitName("target") then
		if strlower(qtarget_newtarget) ~= strlower(strsub(UnitName("target"), 0, strlen(qtarget_newtarget))) then
			-- ignore invalid
			isValid = 2 -- page 2

		-- Alternative, /cleartarget [dead]
		--elseif UnitIsDead("target") and not Qtarget_local.FindCorpse then
		--	-- ignore corpse
		--	isValid = 2 -- page 2

		end
	end

	return isValid
end

function Qtarget_Gettarget()
	local qtarget_newtarget
	local qtarget_newtargetlen
	local qtarget_selected
	qtarget_newtarget = UnitName("target")
	qtarget_newtargetlen = strlen(qtarget_newtarget)
	qtarget_selected = strsub(qtarget_newtarget, 0, qtarget_newtargetlen -1) -- minus last letter
	-- Bug: if exact spelling is used, then not all mobs can be found even if name is clearly
	-- visible and close to player.

	if (qtarget_selected == nil or qtarget_selected == "") then -- nothing selected
		QtargetTargetEdit:SetText("")
	else
		QtargetTargetEdit:SetText(qtarget_selected)
		Qtarget_Target()
	end
end

function Qtarget_OnEvent(event)
	if (event == "VARIABLES_LOADED") then 
		Qtarget_InitLocal() 

	elseif (event == "MINIMAP_UPDATE_ZOOM") then
		QtargetMap_InCity = Qtarget_isMinimapInCity()

	elseif (event == "PLAYER_REGEN_DISABLED") then -- enter combat
		Qtarget_local.isCombat = true

	elseif (event == "PLAYER_REGEN_ENABLED") then -- leave combat
		Qtarget_local.isCombat = nil

	-- elseif (event == "PLAYER_LEAVE_COMBAT") then -- no longer used

	end

	-- mobs are unsupported after patches when using GetPlayerMapPosition() function
	-- only players are targetted now, and not anything else
	--[[
	if (strupper(event) == "UPDATE" or event == "PLAYER_TARGET_CHANGED" or event == "UNIT_FOCUS") then
		local continent, zone = Qtarget_GetCurrentZone()

		if( UnitName("target") ~= nil and UnitName("target") ~= "" and UnitName("target") ~= UnitName("player") and UnitIsPlayer("target") and not ((continent == 0) or (zone == 0))) then
		--if( UnitName("target") ~= nil and UnitName("target") ~= "" and UnitName("target") ~= UnitName("player") and not ((continent == 0) or (zone == 0))) then

			local inCity = QtargetMap_InCity
			local zoomLevel = Minimap:GetZoom()
			local px, py = Qtarget_PlayerPos()	
			--Qtarget_Chat("px, " .. px .. ", " .. py) -- testing only
			if ((px == 0) and (py == 0)) then 
				return 
			end
			local tx, ty = Qtarget_TargetPos()	
			--Qtarget_Chat("tx, " .. tx .. ", " .. ty) -- testing only
			if ((tx == 0) and (ty == 0)) then 
				return 
			end
			
			local qscaleX, qscaleY = Qtarget_GetMapScale(continent, zone, inCity, zoomLevel)
			local absPx, absPy = Qtarget_AbsCoord(continent, zone, px, py)
			local absTx, absTy = Qtarget_AbsCoord(continent, zone, tx, ty)
			
			local dist, deltaX, deltaY = Qtarget_Distance(absPx, absPy, absTx, absTy)
			local offsX, offsY, gDist = Qtarget_MiniMapPos(deltaX, deltaY, qscaleX, qscaleY)

			if (UnitIsEnemy("player","target") or UnitIsPVPFreeForAll("target")) then
				QtargetMinimapIconTexture:SetTexture("Interface\\AddOns\\Qtarget\\gfx\\minimaptargetred")
			else
				QtargetMinimapIconTexture:SetTexture("Interface\\AddOns\\Qtarget\\gfx\\minimaptargetgreen")
			end	
			QtargetMinimapIcon:SetPoint("CENTER", "MinimapCluster", "TOPLEFT", 107 + offsX, -92 - offsY)
			if( not QtargetFrame:IsVisible() ) then
				QtargetMinimapIcon:Show()
			end
		else
			QtargetMinimapIcon:Hide()
		end
	end
	]]
end

function Qtarget_AbsCoord(continent, zone, x, y)
	if ((continent == 0) or (zone == 0)) then return x, y end
	local r = QtargetRegionData[continent][zone]
	local absX = x * r.scale + r.xoffset
	local absY = y * r.scale + r.yoffset
	return absX, absY
end

function Qtarget_isMinimapInCity()
	local tempzoom = 0
	local inCity = false
	if (GetCVar("minimapZoom") == GetCVar("minimapInsideZoom")) then
		if (GetCVar("minimapInsideZoom")+0 >= 3) then 
			Minimap:SetZoom(Minimap:GetZoom() - 1)
			tempzoom = 1
		else
			Minimap:SetZoom(Minimap:GetZoom() + 1)
			tempzoom = -1
		end
	end
	if (GetCVar("minimapInsideZoom")+0 == Minimap:GetZoom()) then inCity = true end
	Minimap:SetZoom(Minimap:GetZoom() + tempzoom)
	return inCity
end

function Qtarget_Distance(originX, originY, targetX, targetY)
	local dx = (targetX - originX)
	local dy = (targetY - originY)
	local d = Qtarget_Pythag(dx, dy)
	return d, dx, dy
end

function Qtarget_Pythag(dx, dy)
	local d = math.sqrt(dx*dx + dy*dy)
	if (d == 0) then 
		d = 0.0000000001
	end
	return d
end

function Qtarget_GetMapScale(continent, zone, inCity, zoomLevel)
	if ((continent == nil) or (zoomLevel == nil)) then return 0,0 end
	if ((not QtargetRegionData) or 
	(not QtargetRegionData[continent]) or 
	(not QtargetRegionData[continent].scales) or 
	(not QtargetRegionData[continent].scales[zoomLevel]) or 
	(not QtargetRegionData[continent].scales[zoomLevel].xscale) or
	(not QtargetRegionData[continent].scales[zoomLevel].yscale)) then
		return 0,0
	end

	local scaleX = QtargetRegionData[continent].scales[zoomLevel].xscale
	local scaleY = QtargetRegionData[continent].scales[zoomLevel].yscale
	if (inCity == true) then
		local cityScale = QtargetRegionData.cityZoom[zoomLevel]
		scaleX = scaleX * cityScale
		scaleY = scaleY * cityScale
	else

	end
	
	return scaleX, scaleY
end

function Qtarget_MiniMapPos(deltaX, deltaY, scaleX, scaleY)
	local mapX = deltaX * scaleX
	local mapY = deltaY * scaleY
	local mapDist = 0
	mapDist = Qtarget_Pythag(mapX, mapY)
	if (mapDist >= 57) then
		local flipAxis = 1
		if (mapX == 0) then mapX = 0.0000000001
		elseif (mapX < 0) then flipAxis = -1
		end
		local angle = math.atan(mapY / mapX)
		mapX = math.cos(angle) * 58 * flipAxis
		mapY = math.sin(angle) * 58 * flipAxis
	end
	return mapX, mapY, mapDist
end

function Qtarget_GetCurrentZone()
	local currentZoneName = GetRealZoneText()
	for zoneName, zoneData in pairs(QtargetZoneData) do
		if (currentZoneName == zoneName) then
			return zoneData.continent, zoneData.zone
		end
	end
	return 0,0
end

function Qtarget_ChangeMap()
	local mapContinent = GetCurrentMapContinent()
	local mapZone = GetCurrentMapZone()
	local minderCurZone = false
	if ((Qtarget_CloseMap ~= nil) and (Qtarget_CloseMap.continent == Qtarget_LastZone.continent) and (Qtarget_CloseMap.zone == Qtarget_LastZone.zone)) then
		minderCurZone = true
	end
	local playerContinent, playerZone = Qtarget_GetCurrentZone()
	Qtarget_LastZone = { continent = playerContinent, zone = playerZone }
	if ((playerContinent == 0) or (playerZone == 0)) then return false end
	if ((playerContinent == mapContinent) and (playerZone == mapZone)) then return true end

	SetMapZoom(playerContinent, playerZone)
	local lastTime = 0
	if ((Qtarget_CloseMap ~= nil) and (Qtarget_CloseMap.time ~= nil)) then
		lastTime = Qtarget_CloseMap.time
	end
	
	if (minderCurZone) then
		Qtarget_MapOpen = false
		Qtarget_CloseMap = { continent = playerContinent, zone = playerZone, time = lastTime }
		Qtarget_OnEvent("WORLD_MAP_UPDATE")
	end
	
	return true
end

function Qtarget_PlayerPos(forced)
	local currentZoneName = GetRealZoneText()
	if (currentZoneName ~= Qtarget_LastZone) then
		forced = true
	end
	Qtarget_LastZone = currentZoneName
	if (forced) then Qtarget_ChangeMap() end

	local px, py = GetPlayerMapPosition("player")
	if ((px == 0) and (py == 0)) then
		if (not forced) then 
			if (Qtarget_ChangeMap()) then
				px, py = GetPlayerMapPosition("player")
			else
				return 0,0
			end
		end
	end
	return px, py
end

function Qtarget_TargetPos(forced)
	local currentZoneName = GetRealZoneText()
	if (currentZoneName ~= Qtarget_LastZone) then
		forced = true
	end
	Qtarget_LastZone = currentZoneName
	if (forced) then Qtarget_ChangeMap() end

	local tx, ty = GetPlayerMapPosition("target")
	-- unsupported function for mobs and will not display coordinates

	if ((tx == 0) and (ty == 0)) then
		if (not forced) then 
			if (Qtarget_ChangeMap()) then
				tx, ty = GetPlayerMapPosition("target")
			else
				return 0,0
			end
		end
	end
	return tx, ty
end

function Qtarget_LoadContinents(...)
--	QtargetZoneData = { }
--	for c=1, arg.n, 1 do
--		local cname = arg[c]
--		Qtarget_LoadZones(c, cname, GetMapZones(c))
--	end
end

function Qtarget_LoadZones(c,cname, ...)
--	for z=1, arg.n, 1 do
--		local zname = arg[z]
--		QtargetZoneData[zname] = { continent=c, zone=z, continentName=cname }
--	end
end

function Qtarget_OnClick()
	local x, y = GetCursorPosition()
	x = x / Minimap:GetScale()
	y = y / Minimap:GetScale()

	local cx, cy = Minimap:GetCenter()
	x = x + CURSOR_OFFSET_X - cx
	y = y + CURSOR_OFFSET_Y - cy
	if ( sqrt(x * x + y * y) < (Minimap:GetWidth() / 2) ) then
		Minimap:PingLocation(x, y)
	end
end


function Qtarget_OnUpdate(arg1)
	-- Initialize edit box after delay
	Qtarget_local.TimeSinceLastUpdate = Qtarget_local.TimeSinceLastUpdate + arg1
	if (Qtarget_local.TimeSinceLastUpdate > QTARGET_UPDATE_RATE) then
		if (Qtarget_local.QtargetTargetEditNeedFocus == 1) then
			QtargetTargetEdit:SetFocus()
			local text = QtargetTargetEdit:GetText()
			local textlen = strlen(text)
			QtargetTargetEdit:HighlightText(0, -1)
			Qtarget_local.QtargetTargetEditNeedFocus = 0
		end
		Qtarget_OnEvent("update")
		Qtarget_local.TimeSinceLastUpdate = 0
	end

	-- Save to macro
	if not Qtarget_local.isSavePending then
	elseif Qtarget_local.isCombat then -- ignore in combat
	else
		local macroID = Qtarget_local.isSavemacroID
		local name = Qtarget_local.isSavename
		local icon = Qtarget_local.isSaveicon
		local body = Qtarget_local.isSavebody
		local loc = Qtarget_local.isSaveloc
		local perCharacter = Qtarget_local.isSaveperCharacter
		if not macroID then
			macroID = CreateMacro(name, icon, body, loc, perCharacter)
		else
			EditMacro(macroID, name, icon, body, loc)
		end

		Qtarget_local.isSavePending = nil -- not needed anymore
		QtargetSubmitButton:SetTextColor(NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b)
	end

	-- Disable when continuous check off
	if not QtargetContinuous:GetChecked() then Qtarget_local.ContinuousEnabled = nil end -- not needed anymore

	-- Disable when no window
	if( not QtargetFrame:IsVisible() and not QtargetFrame:IsShown() ) then Qtarget_local.ContinuousEnabled = nil end -- not needed anymore

	-- Disable when target any friend or enemy including self
	if (UnitIsFriend("player", "target")) then Qtarget_local.ContinuousEnabled = nil end -- not needed anymore
	if (UnitIsTrivial("player", "target")) then Qtarget_local.ContinuousEnabled = nil end -- not needed anymore
	if (UnitCreatureType("target")) then Qtarget_local.ContinuousEnabled = nil end -- not needed anymore
	if (UnitIsCivilian("player", "target")) then Qtarget_local.ContinuousEnabled = nil end -- not needed anymore
	if (UnitIsEnemy( "player", "target")) then Qtarget_local.ContinuousEnabled = nil end -- not needed anymore
	if (UnitAffectingCombat("player") == 1) then Qtarget_local.ContinuousEnabled = nil end -- not needed anymore
	if (UnitAffectingCombat("target") == 1) then Qtarget_local.ContinuousEnabled = nil end -- not needed anymore

	-- Continuous check
	if Qtarget_local.ContinuousEnabled then
		Qtarget_local.TimeSinceLastContinuous = Qtarget_local.TimeSinceLastContinuous + arg1
		if (Qtarget_local.TimeSinceLastContinuous > QTARGET_CONTINUOUS_RATE) then
			Qtarget_Target()
			Qtarget_local.TimeSinceLastContinuous = 0 -- reset timer
		end
	else
		Qtarget_local.TimeSinceLastContinuous = 0 -- not needed anymore
	end

	-- Continuous flash in progress
	if Qtarget_local.ContinuousEnabled then
		Qtarget_local.TimeSinceLastContinuousFlash = Qtarget_local.TimeSinceLastContinuousFlash + arg1
		if (Qtarget_local.TimeSinceLastContinuousFlash > QTARGET_CONTINUOUSFLASH_RATE) then
			if Qtarget_local.TimeSinceLastContinuousFlashIteration == 0 then
				QtargetContinuousText:SetTextColor(1.0, 0.0, 0.0) -- red
				Qtarget_local.TimeSinceLastContinuousFlashIteration = Qtarget_local.TimeSinceLastContinuousFlashIteration + 1
			else
				QtargetContinuousText:SetTextColor(1.0, 1.0, 0.0) -- yellow, restored
				Qtarget_local.TimeSinceLastContinuousFlashIteration = 0
			end
			Qtarget_local.TimeSinceLastContinuousFlash = 0 -- reset timer
		end
	else
		if Qtarget_local.TimeSinceLastContinuousFlashIteration == 0 then
		else
			QtargetContinuousText:SetTextColor(1.0, 1.0, 0.0) -- yellow, restored
		end
		Qtarget_local.TimeSinceLastContinuousFlash = 0 -- not needed anymore
		Qtarget_local.TimeSinceLastContinuousFlashIteration = 0
	end
end

function Qtarget_Savewindow()
	Qtarget_local.FindCorpse = QtargetFindCorpse:GetChecked()
	Qtarget_local.Continuous = QtargetContinuous:GetChecked()
end

function Qtarget_Loadwindow()
	QtargetFindCorpse:SetChecked(Qtarget_local.findcorpse)
	QtargetContinuous:SetChecked(Qtarget_local.Continuous)
end

function Qtarget_Togglecontinuous()
	if QtargetContinuous:GetChecked() then
		QtargetContinuous:SetChecked(nil)
	else
		QtargetContinuous:SetChecked(true)
	end
end

function Qtarget_Togglefindcorpse()
	if QtargetFindCorpse:GetChecked() then
		QtargetFindCorpse:SetChecked(nil)
	else
		QtargetFindCorpse:SetChecked(true)
	end
end

function Qtarget_UpdateLock()
	-- I can not figure out how to stop window from moving
	-- I can not shift-click to move nor can I use fancy lock icon either
	QtargetFrameLockButton:Hide()

	--[[
	if (Qtarget.QtargetLocked) then
		QtargetLockNorm:SetTexture(QTARGET_ADDONLOCATION.."Images\\LockButton-Locked-Up")
		QtargetLockPush:SetTexture(QTARGET_ADDONLOCATION.."Images\\LockButton-Locked-Down")
	else
		QtargetLockNorm:SetTexture(QTARGET_ADDONLOCATION.."Images\\LockButton-Unlocked-Up")
		QtargetLockPush:SetTexture(QTARGET_ADDONLOCATION.."Images\\LockButton-Unlocked-Down")
	end
	]]
end

function Qtarget_ToggleLock()
	if (Qtarget.QtargetLocked) then
		Qtarget.QtargetLocked = nil
		Qtarget_UpdateLock()
	else
		Qtarget.QtargetLocked = true
		Qtarget_UpdateLock()
	end
end

function Qtarget_Chat(msg)
	if( DEFAULT_CHAT_FRAME ) then
		DEFAULT_CHAT_FRAME:AddMessage(msg, 1.0, 1.0, 0.0)
	end
end
